<?php

/**
 * @version     1.0.0
 * @package     com_callback
 * @copyright   Copyright (C) 2014. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Kennedy Kinoti <billing@intrepid.co.ke> - http://www.intrepid.co.ke
 */
// No direct access
defined('_JEXEC') or die;

/**
 * Callback helper.
 */
class CallbackBackendHelper {

    /**
     * Configure the Linkbar.
     */
    public static function addSubmenu($vName = '') {
        		JSubMenuHelper::addEntry(
			JText::_('COM_CALLBACK_TITLE_VENDORS'),
			'index.php?option=com_callback&view=vendors',
			$vName == 'vendors'
		);

    }

    /**
     * Gets a list of the actions that can be performed.
     *
     * @return	JObject
     * @since	1.6
     */
    public static function getActions() {
        $user = JFactory::getUser();
        $result = new JObject;

        $assetName = 'com_callback';

        $actions = array(
            'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.own', 'core.edit.state', 'core.delete'
        );

        foreach ($actions as $action) {
            $result->set($action, $user->authorise($action, $assetName));
        }

        return $result;
    }


}
