<?php

if (!defined('_VALID_MOS') && !defined('_JEXEC'))
    die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

/**
 * @version $Id: standard.php,v 1.4 2005/05/27 19:33:57 ei
 *
 * a special type of 'cash on delivey':
 * @author Max Milbers, Valérie Isaksen
 * @version $Id: standard.php 5075 2011-12-14 16:36:10Z alatak $
 * @package VirtueMart
 * @subpackage payment
 * @copyright Copyright (C) 2004-2008 soeren - All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
 *
 * http://virtuemart.net
 */
if (!class_exists('vmPSPlugin'))
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');

class plgVmPaymentIPay extends vmPSPlugin {

    // instance of class
    public static $_this = false;

    function __construct(& $subject, $config) {
		//if (self::$_this)
		 //   return self::$_this;
		parent::__construct($subject, $config);

	    $this->_loggable = true;
	    $this->tableFields = array_keys($this->getTableSQLFields());
	    $varsToPush = array('payment_logos' => array('', 'char'),
		'countries' => array(0, 'int'),
		'payment_order_total' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
		'payment_currency' => 'char(3) ',
		'min_amount' => array(0, 'int'),
		'max_amount' => array(0, 'int'),
		'cost_per_transaction' => array(0, 'int'),
		'cost_percent_total' => array(0, 'int'),
		'tax_id' => array(0, 'int'),
		'payment_info' => array('', 'string')
	    );

	    $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
	   // self::$_this = $this;

    }

    /**
     * Create the table for this plugin if it does not yet exist.
     * @author Valérie Isaksen
     */
    protected function getVmPluginCreateTableSQL() {
		return $this->createTableSQL('Payment Ipay Table');
    }
    /**
     * Fields to create the payment table
     * @return string SQL Fileds
     */
    function getTableSQLFields() {
		$SQLfields = array(
	    'id' => 'tinyint(1) unsigned NOT NULL AUTO_INCREMENT',
	    'virtuemart_order_id' => 'int(11) UNSIGNED DEFAULT NULL',
	    'order_number' => 'char(32) DEFAULT NULL',
	    'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED DEFAULT NULL',
	    'payment_name' => 'char(255) NOT NULL DEFAULT \'\' ',
	    'payment_order_total' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
	    'payment_currency' => 'char(3) ',
	    'cost_per_transaction' => ' decimal(10,2) DEFAULT NULL ',
	    'cost_percent_total' => ' decimal(10,2) DEFAULT NULL ',
	    'tax_id' => 'smallint(11) DEFAULT NULL'
		);

		return $SQLfields;
    }

    /**
     *
     *
     * @author Valérie Isaksen
     */
    function plgVmConfirmedOrder($cart, $order) {

		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
		    return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
		    return false;
		}
		// 		$params = new JParameter($payment->payment_params);
		$lang = JFactory::getLanguage();
		$filename = 'com_virtuemart';
		$lang->load($filename, JPATH_ADMINISTRATOR);
		
		
		if (!class_exists('VirtueMartModelOrders'))
		    require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		$this->getPaymentCurrency($method);
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="'.$method->payment_currency.'" ';
		$db = &JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_from_db = $db ->loadObject();
		$currency_code = $currency_code_from_db->currency_code_3;

		// $this->getVendorCode($method);
		$qw = 'SELECT vendor_id FROM `#__callback_vendor` ';
		$db1 = &JFactory::getDBO();
		$db1->setQuery($qw);
		$vendor_code_from_db = $db1->loadObject();
		$vendor_code = $vendor_code_from_db->vendor_id;
		//print_r($vendor_code);

		$m1 = 'SELECT mobilemoney FROM `#__callback_vendor` ';
		$db2 = &JFactory::getDBO();
		$db2->setQuery($m1);
		$mobilemoney_from_db = $db2->loadObject();
		$mobilemoney_code = $mobilemoney_from_db->mobilemoney;
		// print_r($mobilemoney_code);

		$m2 = 'SELECT mobilebanking FROM `#__callback_vendor` ';
		$db3 = &JFactory::getDBO();
		$db3->setQuery($m2);
		$mobilebanking_from_db = $db3->loadObject();
		$mobilebanking_code = $mobilebanking_from_db->mobilebanking;
		// print_r($mobilebanking_code);

		$m3 = 'SELECT creditcard FROM `#__callback_vendor` ';
		$db4 = &JFactory::getDBO();
		$db4->setQuery($m3);
		$creditcard_from_db = $db4->loadObject();
		$creditcard_code = $creditcard_from_db->creditcard;
		// print_r($creditcard_code);

		// $m4 = 'SELECT creditcard FROM `#__callback_vendor` ';
		// $db5 = &JFactory::getDBO();
		// $db5->setQuery($m4);
		// $creditcard_from_db = $db4->loadObject();
		// $creditcard_code = $creditcard_from_db->creditcard;
		// print_r($creditcard_code);

	    $this->_virtuemart_paymentmethod_id = $order['details']['BT']->virtuemart_paymentmethod_id;
		$live = 0;
		$mm = $mobilemoney_code;
		$mb = $mobilebanking_code;
		$cc = $creditcard_code;
		$dc = $mobilemoney_code;
		// $mm = 0;
		// $mb = 0;
		// $cc = 1;
		// $dc = 1;
		$mer = "Demo";
		$order_id = $order['details']['BT']->order_number;
		$inv = 1;
		$total = number_format(ceil($order['details']['BT']->order_total), 2, '.', '');
		$phone1 = $order['details']['BT']->phone_1;
		$phone2 = $order['details']['BT']->phone_2;
		$email = $order['details']['BT']->email;
		$vendor_ref = $vendor_code;
		// $currency_code_3 = "KES";
		$currency_code_3 = $currency_code;
		// print_r($currency_code_3);
	   
		$curr = $currency_code_3;
		$p1 = $order['details']['BT']->virtuemart_paymentmethod_id;
		$p2 = $order['details']['BT']->virtuemart_paymentmethod_id;
		$p3 = $order['details']['BT']->virtuemart_paymentmethod_id;
		$p4 = $order['details']['BT']->virtuemart_paymentmethod_id;
		$callbkurl = JURI::base().'plugins/vmpayment/ipay/callback.php';
		// print_r($callbkurl);
		//$callbkurl = "http://192.168.1.2/Joomla_Mart/plugins/vmpayment/ipay/";
		//$callbkurl = "http://localhost/Joomla_Mart/plugins/vmpayment/ipay/callback.php";	//your call back URL can now be set by you and changed at will
		$custemail = 1;					//set to 0 if you don't want the customer to receive a notification via iPay email
		$crl = 0;


		$datastring = $live.$mm.$mb.$dc.$cc.$mer.$order_id.$inv.$total.$phone1.$email.$vendor_ref.$curr.$p1.$p2.$p3.$p4.$callbkurl.$custemail.$crl;

		$hashkey = "demo"; //This is one of the parameters you supply to us during registration
		$datastring;
		//This is a string generated from the data to be posted (see above)
		$hashid = hash_hmac('sha1', $datastring, $hashkey);
		//Set hashing algorithm to SHA1


		$code='<iframe src="https://www.ipayafrica.com/payments/?live='.$live.'&mm='.$mm.'&mb='.$mb.'&dc='.$dc.'&cc='.$cc.'&mer='.$mer.'&oid='.$order_id.'&inv='.$inv.'&ttl='.$total.'&tel='.$phone1.'&eml='.$email.'&vid='.$vendor_ref.'&p1='.$p1.'&p2='.$p2.'&p3='.$p3.'&p4='.$p4.'&crl='.$crl.'&cbk='.$callbkurl.'&cst='.$custemail.'&cur='.$curr.'&hsh='.$hashid.'" height="400" width="700" /></frame>';
	
		$html = $code;
	
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
		$cd = CurrencyDisplay::getInstance($cart->pricesCurrency);
	
	
		$this->_virtuemart_paymentmethod_id = $order['details']['BT']->virtuemart_paymentmethod_id;
		$dbValues['payment_name'] = $this->renderPluginName($method);
		$dbValues['order_number'] = $order['details']['BT']->order_number;
		$dbValues['virtuemart_paymentmethod_id'] = $this->_virtuemart_paymentmethod_id;
		$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		$dbValues['cost_percent_total'] = $method->cost_percent_total;
		$dbValues['payment_currency'] = $currency_code_3 ;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency;
		$dbValues['tax_id'] = $method->tax_id;
		$this->storePSPluginInternalData($dbValues);
	
		return $this->processConfirmedOrderPaymentResponse(true, $cart, $order, $code); // return true, empty cart, send order
		
    }

    /**
     * Display stored payment data for an order
     *
     */
    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id) {
		if (!$this->selectedThisByMethodId($virtuemart_payment_id)) {
	   	return null; // Another method was selected, do nothing
	 	}

		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` '
			. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject())) {
		    vmWarn(500, $q . " " . $db->getErrorMsg());
		    return '';
		}
		$this->getPaymentCurrency($paymentTable);
	
		$html = '<table class="adminlist">' . "\n";
		$html .=$this->getHtmlHeaderBE();
		$html .= $this->getHtmlRowBE('STANDARD_PAYMENT_NAME', $paymentTable->payment_name);
		$html .= $this->getHtmlRowBE('STANDARD_PAYMENT_TOTAL_CURRENCY', $paymentTable->payment_order_total.' '.$paymentTable->payment_currency);
		$html .= '</table>' . "\n";
		return $html;
    }

    function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
		if (preg_match('/%$/', $method->cost_percent_total)) {
		    $cost_percent_total = substr($method->cost_percent_total, 0, -1);
		} else {
		    $cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
    }

    /**
     * Check if the payment conditions are fulfilled for this payment method
     * @author: Valerie Isaksen
     *
     * @param $cart_prices: cart prices
     * @param $payment
     * @return true: if the conditions are fulfilled, false otherwise
     *
     */
    protected function checkConditions($cart, $method, $cart_prices) {

		// $params = new JParameter($payment->payment_params);
		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);
	
		$amount = $cart_prices['salesPrice'];
		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0) ));
		if (!$amount_cond) {
		    return false;
		}
		$countries = array();
		if (!empty($method->countries)) {
		    if (!is_array($method->countries)) {
			$countries[0] = $method->countries;
		    } else {
			$countries = $method->countries;
		    }
		}
	
		// probably did not gave his BT:ST address
		if (!is_array($address)) {
		    $address = array();
		    $address['virtuemart_country_id'] = 0;
		}
	
		if (!isset($address['virtuemart_country_id']))
		    $address['virtuemart_country_id'] = 0;
		if (count($countries) == 0 || in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
		    return true;
		}
	
		return false;
    }

    /*
     * We must reimplement this triggers for joomla 1.7
     */

    /**
     * Create the table for this plugin if it does not yet exist.
     * This functions checks if the called plugin is active one.
     * When yes it is calling the standard method to create the tables
     * @author Valérie Isaksen
     *
     */
    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {
		return $this->onStoreInstallPluginTable($jplugin_id);
    }

    /**
     * This event is fired after the payment method has been selected. It can be used to store
     * additional payment info in the cart.
     *
     * @author Max Milbers
     * @author Valérie isaksen
     *
     * @param VirtueMartCart $cart: the actual cart
     * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
     *
     */
    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
		return $this->OnSelectCheck($cart);
    }

    /**
     * plgVmDisplayListFEPayment
     * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
     *
     * @param object $cart Cart object
     * @param integer $selected ID of the method selected
     * @return boolean True on succes, false on failures, null when this plugin was not selected.
     * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
     *
     * @author Valerie Isaksen
     * @author Max Milbers
     */
    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE($cart, $selected, $htmlIn);
    }

    /*
     * plgVmonSelectedCalculatePricePayment
     * Calculate the price (value, tax_id) of the selected method
     * It is called by the calculator
     * This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
     * @author Valerie Isaksen
     * @cart: VirtueMartCart the current cart
     * @cart_prices: array the new cart prices
     * @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
     *
     *
     */

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
		    return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
		    return false;
		}
		 $this->getPaymentCurrency($method);
	
		$paymentCurrencyId = $method->payment_currency;


	}

		// function plgVmgetVendorCode($vendor_CodeId) {
		// $this->getVendorCode($method);
		// $vendor_CodeId = $method->vendor_code;
		// }

    /**
     * plgVmOnCheckAutomaticSelectedPayment
     * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
     * The plugin must check first if it is the correct type
     * @author Valerie Isaksen
     * @param VirtueMartCart cart: the cart object
     * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
     *
     */
    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    /**
     * This method is fired when showing the order details in the frontend.
     * It displays the method-specific data.
     *
     * @param integer $order_id The order ID
     * @return mixed Null for methods that aren't active, text (HTML) otherwise
     * @author Max Milbers
     * @author Valerie Isaksen
     */
    protected function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    /**
     * This event is fired during the checkout process. It can be used to validate the
     * method data as entered by the user.
     *
     * @return boolean True when the data was valid, false otherwise. If the plugin is not activated, it should return null.
     * @author Max Milbers

      public function plgVmOnCheckoutCheckDataPayment(  VirtueMartCart $cart) {
      return null;
      }
     */

    /**
     * This method is fired when showing when priting an Order
     * It displays the the payment method-specific data.
     *
     * @param integer $_virtuemart_order_id The order ID
     * @param integer $method_id  method used for this order
     * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
     * @author Valerie Isaksen
     */
    function plgVmonShowOrderPrintPayment($order_number, $method_id) {
		return $this->onShowOrderPrint($order_number, $method_id);
    }

    function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
		return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
		return $this->setOnTablePluginParams($name, $id, $table);
    }
    
    function plgVmOnSelectPayment() {
    	$code = '<form method="post" action="https://www.gateway.com/3dsecure/">
		<input type="hidden" name="gwlogin" value="'.$params["loginid"].'">
		<input type="hidden" name="invoiceid" value="'.$params["invoiceid"].'">
		<input type="hidden" name="amount" value="'. $params["amount"].'">
		<input type="hidden" name="firstname" value="'. $params["clientdetails"]["firstname"].'">
		<input type="hidden" name="lastname" value="'. $params["clientdetails"]["lastname"].'">
		<input type="hidden" name="address" value="'. $params["clientdetails"]["address1"].'">
		<input type="hidden" name="city" value="'. $params["clientdetails"]["city"].'">
		<input type="hidden" name="state" value="'. $params["clientdetails"]["state"].'">
		<input type="hidden" name="postcode" value="'. $params["clientdetails"]["postcode"].'">
		<input type="hidden" name="country" value="'. $params["clientdetails"]["country"].'">
		<input type="hidden" name="phonenumber" value="'. $params["clientdetails"]["phonenumber"].'">
		<input type="hidden" name="email" value="'. $params["clientdetails"]["email"].'">
		<input type="hidden" name="ccnumber" value="'. $params["cardnum"].'">
		<input type="hidden" name="expirymonth" value="'.substr($params['cardexp'],0,2).'">
		<input type="hidden" name="expiryyear" value="'.substr($params['cardexp'],2,2).'">
		<input type="hidden" name="cvv2" value="'. $params["cccvv"].'">
		<input type="hidden" name="return_url" value="'.
		$params['systemurl'].'/modules/gateways/callback/yourgatewayname.php">
		<noscript>
		<div class="errorbox"><b>JavaScript is currently disabled or is not supported by your
		browser.</b><br />Please click the continue button to proceed with the processing of your
		transaction.</div>
		<p align="center"><input type="submit" value="Continue >>" /></p>
		</noscript>
		</form>';
	return $code;

    }
    
     /**
     * plgVmOnPaymentResponseReceived
     * This event is fired when the  method returns to the shop after the transaction
     *
     *  the method itself should send in the URL the parameters needed
     * NOTE for Plugin developers:
     *  If the plugin is NOT actually executed (not the selected payment method), this method must return NULL
     *
     * @param int $virtuemart_order_id : should return the virtuemart_order_id
     * @param text $html: the html to display
     * @return mixed Null when this method was not selected, otherwise the true or false
     *
     * @author Valerie Isaksen
     *
     * */
     function plgVmOnPaymentResponseReceived(&$virtuemart_order_id, &$html) {
				if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
			$payment_data = JRequest::get('get'); //get returned variables from iPay
			vmdebug('plgVmOnPaymentResponseReceived', $payment_data);
			$ipay_status = $payment_data['status'];
			$order_number = $payment_data['id'];
			$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
			$this->logInfo('plgVmOnPaymentNotification: virtuemart_order_id  found ' . $virtuemart_order_id, 'message');
			
						
		   // the payment itself should send the parameter needed.
			$virtuemart_paymentmethod_id = JRequest::getInt('p1', 0);
		
			if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			    return null; // Another method was selected, do nothing
			}
			if (!$this->selectedThisElement($method->payment_element)) {
			    return false;
			}
			
			$db = JFactory::getDBO();
			$session = JFactory::getSession();
			$return_context = $session->getId();
			if (strcmp($ipay_status, 'aei7p7yrx4ae34') == 0): //for success..
				$new_status = 'C';
				$msg = 'Your transaction was successful.';
	    	elseif(strcmp($ipay_status, 'bdi6p2yy76etrs') == 0): //pending..
	    		$new_status = 'P';
				$msg = 'Your transaction is pending. Please try again later';
			elseif(strcmp($ipay_status, 'eq3i7p5yt7645e') == 0): //more.. 		
				$new_status = 'C';
				$msg = 'Your transaction was successful.However,the amount you sent was more than required. Please notify your merchant.';			
			elseif(strcmp($ipay_status, 'cr5i3pgy9867e1') == 0): //already used..
				$new_status = 'P';
				$msg = 'You are trying to use a code that has already been used. Please use a valid code';
			endif;
			
			$this->logInfo('plgVmOnPaymentNotification return new_status' . $new_status, 'message');

			$this->emptyCart($return_context);
			
			$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
			
			if ($virtuemart_order_id) {
			    // send the email only if payment has been accepted
			    if (!class_exists('VirtueMartModelOrders'))
				require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
			    $modelOrder = new VirtueMartModelOrders();
			    $orders[$virtuemart_order_id]['order_status'] = $new_status;
			    $orders[$virtuemart_order_id]['virtuemart_order_id'] = $virtuemart_order_id;
			    $orders[$virtuemart_order_id]['customer_notified'] = 0;
			    
			    $modelOrder->updateOrderStatus($orders); // take directly the session from the DB
			    
			    $order_data = $this->getDataByOrderId($virtuemart_order_id);
				 $payment_name = $this->renderPluginName($method);
			    $html = $this->_getPaymentResponseHtml($payment_data, $payment_name, $order_data, $msg);
		       // echo $html;
			    // remove vmcart
			}
			
			
			return true;
    }
    
    function emptyCart($session_name) {

    }
    
    function _getPaymentResponseHtml($paypal_data, $payment_name , $order_data, $msg) {

		$html = '<table>' . "\n";
		
			$html .= '<thead><th colspan="2"><b>' . $msg ."</b></th></thead>";
			$html .= '<tr><td>Payment Method</td><td>' . $payment_name ."</td></tr>";
			$html .= '<tr><td>Order Number</td><td>' . $paypal_data['id'] ."</td></tr>";
			$html .= '<tr><td>Amount</td><td>' . $order_data->payment_currency.'  '.number_format(round($order_data->payment_order_total), 2) ."</td></tr>";

		$html .= '</table>' . "\n";

		return $html;
    }
    

    //Notice: We only need to add the events, which should work for the specific plugin, when an event is doing nothing, it should not be added

    /**
     * Save updated order data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk
     *
      public function plgVmOnUpdateOrderPayment(  $_formData) {
      return null;
      }

      /**
     * Save updated orderline data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk
     *
      public function plgVmOnUpdateOrderLine(  $_formData) {
      return null;
      }

      /**
     * plgVmOnEditOrderLineBE
     * This method is fired when editing the order line details in the backend.
     * It can be used to add line specific package codes
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk
     *
      public function plgVmOnEditOrderLineBEPayment(  $_orderId, $_lineId) {
      return null;
      }

      /**
     * This method is fired when showing the order details in the frontend, for every orderline.
     * It can be used to display line specific package codes, e.g. with a link to external tracking and
     * tracing systems
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk
     *
      public function plgVmOnShowOrderLineFE(  $_orderId, $_lineId) {
      return null;
      }

      /**
     * This event is fired when the  method notifies you when an event occurs that affects the order.
     * Typically,  the events  represents for payment authorizations, Fraud Management Filter actions and other actions,
     * such as refunds, disputes, and chargebacks.
     *
     * NOTE for Plugin developers:
     *  If the plugin is NOT actually executed (not the selected payment method), this method must return NULL
     *
     * @param $return_context: it was given and sent in the payment form. The notification should return it back.
     * Used to know which cart should be emptied, in case it is still in the session.
     * @param int $virtuemart_order_id : payment  order id
     * @param char $new_status : new_status for this order id.
     * @return mixed Null when this method was not selected, otherwise the true or false
     *
     * @author Valerie Isaksen
     *
     *
      public function plgVmOnPaymentNotification() {
      return null;
      }

      /**
     * plgVmOnPaymentResponseReceived
     * This event is fired when the  method returns to the shop after the transaction
     *
     *  the method itself should send in the URL the parameters needed
     * NOTE for Plugin developers:
     *  If the plugin is NOT actually executed (not the selected payment method), this method must return NULL
     *
     * @param int $virtuemart_order_id : should return the virtuemart_order_id
     * @param text $html: the html to display
     * @return mixed Null when this method was not selected, otherwise the true or false
     *
     * @author Valerie Isaksen
     *
     *
      function plgVmOnPaymentResponseReceived(, &$virtuemart_order_id, &$html) {
      return null;
      }
     */
}

// No closing tag
	
